blob: 36c0896ec8a39aeb7ee3608f477d940f4865539d [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Thomas Heijligenf579bba2021-10-12 12:48:01 +020031STRIP_ARGS = -s
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000032INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000033DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000034PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000035MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010036CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000037EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000038RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000039PKG_CONFIG ?= pkg-config
40BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000041
Stefan Taunerfd0d4132012-09-25 21:24:55 +000042# The following parameter changes the default programmer that will be used if there is no -p/--programmer
43# argument given when running flashrom. The predefined setting does not enable any default so that every
44# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
45# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
46# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
47# system attached to an external programmer while the default programmer is set to the internal programmer, and
48# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
49# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
51CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000052# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020053CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000054# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020055# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000056# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000057
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000058# If your compiler spits out excessive warnings, run make WARNERROR=no
59# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000060WARNERROR ?= yes
61
62ifeq ($(WARNERROR), yes)
63CFLAGS += -Werror
64endif
65
Stefan Taunere37735a2015-01-26 22:03:35 +000066ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000067PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000068override CPPFLAGS += -I$(LIBS_BASE)/include
69override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000070endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000071
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000073override PKG_CONFIG += --static
74override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075endif
76
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077# Set LC_ALL=C to minimize influences of the locale.
78# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060079# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080LC_ALL=C
81export LC_ALL
82
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000083dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000084
85# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
86# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090087debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
88 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000089
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000090###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020091# Dependency handling.
92
93DEPENDS_ON_SERIAL := \
94 CONFIG_BUSPIRATE_SPI \
95 CONFIG_PONY_SPI \
96 CONFIG_SERPROG \
97
98DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020099 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200100 CONFIG_INTERNAL \
101 CONFIG_NICINTEL_SPI \
102 CONFIG_OGP_SPI \
103 CONFIG_PONY_SPI \
104 CONFIG_RAYER_SPI \
105
106DEPENDS_ON_LIBPCI := \
107 CONFIG_ATAHPT \
108 CONFIG_ATAPROMISE \
109 CONFIG_ATAVIA \
110 CONFIG_DRKAISER \
111 CONFIG_GFXNVIDIA \
112 CONFIG_INTERNAL \
113 CONFIG_IT8212 \
114 CONFIG_NIC3COM \
115 CONFIG_NICINTEL \
116 CONFIG_NICINTEL_EEPROM \
117 CONFIG_NICINTEL_SPI \
118 CONFIG_NICNATSEMI \
119 CONFIG_NICREALTEK \
120 CONFIG_OGP_SPI \
121 CONFIG_SATAMV \
122 CONFIG_SATASII \
123
124DEPENDS_ON_LIBUSB1 := \
125 CONFIG_CH341A_SPI \
126 CONFIG_DEDIPROG \
127 CONFIG_DEVELOPERBOX_SPI \
128 CONFIG_DIGILENT_SPI \
129 CONFIG_PICKIT2_SPI \
130 CONFIG_RAIDEN_DEBUG_SPI \
131 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200132 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200133
134DEPENDS_ON_LIBFTDI := \
135 CONFIG_FT2232_SPI \
136 CONFIG_USBBLASTER_SPI \
137
138DEPENDS_ON_LIBJAYLINK := \
139 CONFIG_JLINK_SPI \
140
Nico Hubera54f5a42021-06-27 14:27:41 +0200141
142ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
143$(call disable_all,$(DEPENDS_ON_LIBUSB1))
144endif
145
146ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
147$(call disable_all,$(DEPENDS_ON_LIBPCI))
148endif
149
Nico Huber7f898972021-06-27 13:30:50 +0200150###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000151# General OS-specific settings.
152# 1. Prepare for later by gathering information about host and target OS
153# 2. Set compiler flags and parameters according to OSes
154# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000155
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000156# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000157HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100158ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000159# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
160CC = gcc
161endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100162
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000163# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000164# IMPORTANT: The following line must be placed before TARGET_OS is ever used
165# (of course), but should come after any lines setting CC because the line
166# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900167override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
168 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000169
170ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000171override CPPFLAGS += -I/opt/local/include -I/usr/local/include
172override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000173endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000174
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000175ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000176override CPPFLAGS += -I/usr/local/include
177override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000178endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000179
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000180ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000181override CPPFLAGS += -I/usr/local/include
182override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000183endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000184
Stefan Taunerc65b8552013-09-12 15:48:39 +0000185ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000186# Needs special `pciutils/pci.h` for older NetBSD packages
187PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
188override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000189override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000190endif
191
192ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000193override CPPFLAGS += -I/usr/local/include
194override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000195endif
196
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000197ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000198EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000199# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000200override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000201LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200202# Missing serial support.
203$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
204# Libraries not available for DOS
205$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000206endif
Ollie Lho184a4042005-11-26 21:55:36 +0000207
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000208# FIXME: Should we check for Cygwin/MSVC as well?
209ifeq ($(TARGET_OS), MinGW)
210EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000211# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000212FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000213# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000214# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000215FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100216
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000217# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200218$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
219# And programmers that need raw access.
220$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000221
Nico Huberca621782021-06-27 13:53:49 +0200222else # No MinGW
223
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100224# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200225$(call mark_unsupported,CONFIG_NI845X_SPI)
226
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100227endif
228
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000229ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000230ifeq ($(MAKECMDGOALS),)
231.DEFAULT_GOAL := libflashrom.a
232$(info Setting default goal to libflashrom.a)
233endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000234FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200235$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000236# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200237$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000238# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200239$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100240# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200241$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000242endif
243
Nico Huberdc8e54a2021-06-27 14:17:34 +0200244# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
245ifeq ($(filter $(TARGET_OS),Linux Android), )
246$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
247$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000248endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000249
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000250ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200251# Android on x86 (currently) does not provide raw PCI port I/O operations.
252$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000253endif
254
Stefan Tauner037cd842013-08-25 00:10:56 +0000255###############################################################################
256# General architecture-specific settings.
257# Like above for the OS, below we verify user-supplied options depending on the target architecture.
258
Uwe Hermann44ffd582011-08-20 14:16:00 +0000259# Determine the destination processor architecture.
260# IMPORTANT: The following line must be placed before ARCH is ever used
261# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000262# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900263override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
264 | tail -1 | cut -f 2 -d'"'))
265override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
266 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000267
Nico Huberc8801732017-12-01 18:19:43 +0000268# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
269ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200270$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000271endif
272
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000273# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000274# Right now this means the drivers below only work on x86.
275ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200276$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
277$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
278$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000279endif
280
Nico Huber8945b812021-06-27 14:24:53 +0200281# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
282# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000283# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700284ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200285$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
286$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
287$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000288endif
289
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000290###############################################################################
291# Flash chip drivers and bus support infrastructure.
292
Stefan Tauner4404f732013-09-12 08:28:56 +0000293CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000294 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300295 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100296 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
297 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000298
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000299###############################################################################
300# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000301
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200302LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000303
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000304###############################################################################
305# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000306
Stefan Tauner9b32de92014-08-08 23:52:33 +0000307CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000308
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200309# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
310# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
311# be obtained using util/getrevision.sh, which is the common case during development.
312-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200313VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200314MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000315
Stefan Tauner76347082016-11-27 17:45:49 +0100316SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000317
Stefan Tauner76347082016-11-27 17:45:49 +0100318# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100319ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100320$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100321endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000322
Stefan Tauner037cd842013-08-25 00:10:56 +0000323###############################################################################
324# Default settings of CONFIG_* variables.
325
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000326# Always enable internal/onboard support for now.
327CONFIG_INTERNAL ?= yes
328
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000329# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000330CONFIG_SERPROG ?= yes
331
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000332# RayeR SPIPGM hardware support
333CONFIG_RAYER_SPI ?= yes
334
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000335# PonyProg2000 SPI hardware support
336CONFIG_PONY_SPI ?= yes
337
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000338# Always enable 3Com NICs for now.
339CONFIG_NIC3COM ?= yes
340
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000341# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
342CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000343
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000344# Always enable SiI SATA controllers for now.
345CONFIG_SATASII ?= yes
346
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000347# Highpoint (HPT) ATA/RAID controller support.
348# IMPORTANT: This code is not yet working!
349CONFIG_ATAHPT ?= no
350
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000351# VIA VT6421A LPC memory support
352CONFIG_ATAVIA ?= yes
353
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000354# Promise ATA controller support.
355CONFIG_ATAPROMISE ?= no
356
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000357# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000358CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000359
James Lairdc60de0e2013-03-27 13:00:23 +0000360# Always enable Altera USB-Blaster dongles for now.
361CONFIG_USBBLASTER_SPI ?= yes
362
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000363# MSTAR DDC support needs more tests/reviews/cleanups.
364CONFIG_MSTARDDC_SPI ?= no
365
Justin Chevrier66e554b2015-02-08 21:58:10 +0000366# Always enable PICkit2 SPI dongles for now.
367CONFIG_PICKIT2_SPI ?= yes
368
Miklós Márton324929c2019-08-01 19:14:10 +0200369# Always enable STLink V3
370CONFIG_STLINKV3_SPI ?= yes
371
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000372# Always enable dummy tracing for now.
373CONFIG_DUMMY ?= yes
374
375# Always enable Dr. Kaiser for now.
376CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000377
Joerg Fischer5665ef32010-05-21 21:54:07 +0000378# Always enable Realtek NICs for now.
379CONFIG_NICREALTEK ?= yes
380
Andrew Morganc29c2e72010-06-07 22:37:54 +0000381# Disable National Semiconductor NICs until support is complete and tested.
382CONFIG_NICNATSEMI ?= no
383
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000384# Always enable Intel NICs for now.
385CONFIG_NICINTEL ?= yes
386
Idwer Vollering004f4b72010-09-03 18:21:21 +0000387# Always enable SPI on Intel NICs for now.
388CONFIG_NICINTEL_SPI ?= yes
389
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000390# Always enable EEPROM on Intel NICs for now.
391CONFIG_NICINTEL_EEPROM ?= yes
392
Mark Marshall90021f22010-12-03 14:48:11 +0000393# Always enable SPI on OGP cards for now.
394CONFIG_OGP_SPI ?= yes
395
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000396# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000397CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000398
Simon Glassae616512016-01-23 23:27:58 +0000399# Always enable Dediprog SF100 for now.
400CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000401
Daniel Thompson45e91a22018-06-04 13:46:29 +0100402# Always enable Developerbox emergency recovery for now.
403CONFIG_DEVELOPERBOX_SPI ?= yes
404
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000405# Always enable Marvell SATA controllers for now.
406CONFIG_SATAMV ?= yes
407
David Hendricksf9a30552015-05-23 20:30:30 -0700408# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
409CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000410CONFIG_LINUX_SPI ?= yes
411
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000412# Always enable ITE IT8212F PATA controllers for now.
413CONFIG_IT8212 ?= yes
414
Urja Rannikko0870b022016-01-31 22:10:29 +0000415# Winchiphead CH341A
416CONFIG_CH341A_SPI ?= yes
417
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100418# Digilent Development board JTAG
419CONFIG_DIGILENT_SPI ?= yes
420
Jean THOMASe28d8e42022-10-11 17:54:30 +0200421# DirtyJTAG
422CONFIG_DIRTYJTAG_SPI ?= yes
423
Marc Schink3578ec62016-03-17 16:23:03 +0100424# Disable J-Link for now.
425CONFIG_JLINK_SPI ?= no
426
Nico Huber83d52072021-06-27 00:07:13 +0200427# National Instruments USB-845x is Windows only and needs a proprietary library.
428CONFIG_NI845X_SPI ?= no
429
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000430# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000431CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000432
Stefan Taunerf3503372016-02-26 23:51:21 +0000433# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
434ifeq ($(CONFIG_NOTHING), yes)
435 ifeq ($(CONFIG_EVERYTHING), yes)
436 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
437 endif
438 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
439 $(if $(filter yes, $($(var))),\
440 $(eval $(var)=no)))
441endif
442
Patrick Georgiced7ab62015-01-19 19:52:34 +0000443# Enable all features if CONFIG_EVERYTHING=yes is given
444ifeq ($(CONFIG_EVERYTHING), yes)
445$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
446 $(if $(filter no, $($(var))),\
447 $(eval $(var)=yes)))
448endif
449
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000450# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200451
452ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200453override CONFIG_BITBANG_SPI = yes
454else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000455CONFIG_BITBANG_SPI ?= no
456endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000457
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000458###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000459# Handle CONFIG_* variables that depend on others set (and verified) above.
460
461# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
462ifeq ($(TARGET_OS), libpayload)
463ifeq ($(CONFIG_INTERNAL), yes)
464ifeq ($(CONFIG_INTERNAL_DMI), no)
465UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
466else
467override CONFIG_INTERNAL_DMI = yes
468endif
469endif
470endif
471
472# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
473CONFIG_INTERNAL_DMI ?= yes
474
475###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000476# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000477# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000478
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200479ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
480FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
481else
482FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
483endif
484
Stefan Tauner265fcac2014-06-02 00:12:23 +0000485FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000486
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000487ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000488FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000489PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000490ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000491PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200492PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000493ifeq ($(CONFIG_INTERNAL_DMI), yes)
494FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
495endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000496else
497endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000498endif
499
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000500ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000501FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000502PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000503NEED_SERIAL += CONFIG_SERPROG
504NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000505endif
506
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000507ifeq ($(CONFIG_RAYER_SPI), yes)
508FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
509PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000510NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000511endif
512
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000513ifeq ($(CONFIG_PONY_SPI), yes)
514FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
515PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000516NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000517endif
518
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000519ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000520FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000521PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000522endif
523
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000524ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000525FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000526PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000527endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000528
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000529ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000530FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000531PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000532endif
533
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000534ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000535FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000536PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000537endif
538
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000539ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000540FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000541PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000542endif
543
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000544ifeq ($(CONFIG_ATAVIA), yes)
545FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
546PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000547endif
548
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000549ifeq ($(CONFIG_ATAPROMISE), yes)
550FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
551PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000552endif
553
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000554ifeq ($(CONFIG_IT8212), yes)
555FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
556PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000557endif
558
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000559ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000560# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000561FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000562PROGRAMMER_OBJS += ft2232_spi.o
563endif
564
565ifeq ($(CONFIG_USBBLASTER_SPI), yes)
566# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000567FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000568PROGRAMMER_OBJS += usbblaster_spi.o
569endif
570
Justin Chevrier66e554b2015-02-08 21:58:10 +0000571ifeq ($(CONFIG_PICKIT2_SPI), yes)
572FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
573PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000574endif
575
Miklós Márton324929c2019-08-01 19:14:10 +0200576ifeq ($(CONFIG_STLINKV3_SPI), yes)
577FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
578PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200579endif
580
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000581ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000582FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000583PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000584endif
585
586ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000587FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000588PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000589endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000590
Joerg Fischer5665ef32010-05-21 21:54:07 +0000591ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000592FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000593PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000594endif
595
Andrew Morganc29c2e72010-06-07 22:37:54 +0000596ifeq ($(CONFIG_NICNATSEMI), yes)
597FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
598PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000599endif
600
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000601ifeq ($(CONFIG_NICINTEL), yes)
602FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
603PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000604endif
605
Idwer Vollering004f4b72010-09-03 18:21:21 +0000606ifeq ($(CONFIG_NICINTEL_SPI), yes)
607FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
608PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000609endif
610
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000611ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
612FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
613PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000614endif
615
Mark Marshall90021f22010-12-03 14:48:11 +0000616ifeq ($(CONFIG_OGP_SPI), yes)
617FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
618PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000619endif
620
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000621ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
622FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000623PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000624NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000625endif
626
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000627ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000628FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000629PROGRAMMER_OBJS += dediprog.o
630endif
631
Daniel Thompson45e91a22018-06-04 13:46:29 +0100632ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
633FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
634PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100635endif
636
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000637ifeq ($(CONFIG_SATAMV), yes)
638FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
639PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000640endif
641
David Hendricksf9a30552015-05-23 20:30:30 -0700642ifeq ($(CONFIG_LINUX_MTD), yes)
643# This is a totally ugly hack.
644FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
645PROGRAMMER_OBJS += linux_mtd.o
646endif
647
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000648ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000649# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000650FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000651PROGRAMMER_OBJS += linux_spi.o
652endif
653
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000654ifeq ($(CONFIG_MSTARDDC_SPI), yes)
655# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000656FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000657NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000658PROGRAMMER_OBJS += mstarddc_spi.o
659endif
660
Urja Rannikko0870b022016-01-31 22:10:29 +0000661ifeq ($(CONFIG_CH341A_SPI), yes)
662FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
663PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000664endif
665
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100666ifeq ($(CONFIG_DIGILENT_SPI), yes)
667FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
668PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100669endif
670
Jean THOMASe28d8e42022-10-11 17:54:30 +0200671ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
672FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
673PROGRAMMER_OBJS += dirtyjtag_spi.o
674endif
675
Marc Schink3578ec62016-03-17 16:23:03 +0100676ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100677FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
678PROGRAMMER_OBJS += jlink_spi.o
679endif
680
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100681ifeq ($(CONFIG_NI845X_SPI), yes)
682FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
683
684ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
685# if the user did not specified the NI-845x headers/lib path
686# do a guess for both 32 and 64 bit Windows versions
687NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100688NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200689
690# hack to access env variable containing brackets...
691PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
692
693ifneq ($(PROGRAMFILES_X86DIR),)
694ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
695NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
696NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
697endif
698endif
699
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100700else
701NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
702NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
703endif
704
705FEATURE_CFLAGS += $(NI845X_INCLUDES)
706LIBS += -lni845x
707PROGRAMMER_OBJS += ni845x_spi.o
708endif
709
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000710ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200711LIB_OBJS += serial.o
712ifeq ($(TARGET_OS), Linux)
713LIB_OBJS += custom_baud_linux.o
714else
715LIB_OBJS += custom_baud.o
716endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000717endif
718
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000719ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000720ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000721LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000722endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000723endif
724
Nico Huberf55ca202021-06-27 14:36:06 +0200725NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000726ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000727CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000728# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
729# libpci may need raw memory, MSR or PCI port I/O on some platforms.
730# Individual drivers might have the same needs as well.
731NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000732FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000733FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000734
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000735PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000736ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000737# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000738PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000739else
740PCILIBS += -lpci
741endif
742endif
743
744ifneq ($(NEED_RAW_ACCESS), )
745# Raw memory, MSR or PCI port I/O access.
746FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
747PROGRAMMER_OBJS += physmap.o hwaccess.o
748
749ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200750ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000751PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200752endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000753else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000754ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200755ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000756PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200757endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000758else
759ifeq ($(TARGET_OS), Darwin)
760# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000761PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000762endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000763endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000764endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000765
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000766endif
767
Nico Huberf55ca202021-06-27 14:36:06 +0200768NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000769ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000770CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100771PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000772# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
773ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
774USB1LIBS += -lusb
775else
776ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000777override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000778USB1LIBS += -lusb-1.0
779else
Stefan Tauner45207062016-02-19 08:17:24 +0000780USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
781override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000782endif
783endif
784endif
785
Nico Huberf55ca202021-06-27 14:36:06 +0200786NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200787ifneq ($(NEED_LIBFTDI), )
788FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
789FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
790FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
791FEATURE_CFLAGS += $(FTDI_INCLUDES)
792FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
793# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
794# into a hard requirement for libusb, defeating the purpose of auto-enabling.
795endif
796
Nico Huberf55ca202021-06-27 14:36:06 +0200797NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100798ifneq ($(NEED_LIBJAYLINK), )
799CHECK_LIBJAYLINK = yes
800JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
801override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
802endif
803
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000804ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000805FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000806CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000807endif
808
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000809FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000810
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000811# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000812FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000813
Nico Huber8624e8c2012-11-05 21:46:33 +0100814FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
815FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
816
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000817LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000818OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000819
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000820all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000821ifeq ($(ARCH), x86)
822 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
823endif
824
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000825$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100826 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000827
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000828libflashrom.a: $(LIBFLASHROM_OBJS)
829 $(AR) rcs $@ $^
830 $(RANLIB) $@
831
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000832# TAROPTIONS reduces information leakage from the packager's system.
833# If other tar programs support command line arguments for setting uid/gid of
834# stored files, they can be handled here as well.
835TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000836
Paul Fox05dfbe62009-06-16 21:08:06 +0000837%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100838 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000839
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000840# Make sure to add all names of generated binaries here.
841# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000842# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000843clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000844 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000845 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000846
Ollie Lho184a4042005-11-26 21:55:36 +0000847distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000848 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000849
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000850strip: $(PROGRAM)$(EXEC_SUFFIX)
851 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000852
Stefan Tauner56787082011-08-18 02:27:19 +0000853# to define test programs we use verbatim variables, which get exported
854# to environment variables and are referenced with $$<varname> later
855
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000856compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000857 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000858 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000859 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000860 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
861 echo "found." || { echo "not found."; \
862 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000863 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000864 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000865 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000866 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900867 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000868 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000869 @printf "Target OS is "
870 @# FreeBSD wc will output extraneous whitespace.
871 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900872 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000873 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000874ifeq ($(TARGET_OS), libpayload)
875 @$(CC) --version 2>&1 | grep -q coreboot || \
876 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
877 echo "This might work but usually does not, please beware." )
878endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000879
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000880hwlibs: compiler
881 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000882ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000883 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000884 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000885 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
887 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000888 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000889 echo "Please install libpci headers or disable all features"; \
890 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000891 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000892 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
893 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000894 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000895 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000896 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000897 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000898 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
899 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000900 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000901 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
902 echo "yes." || { echo "no."; \
903 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000904 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
905 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000906 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000907 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000908 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
909 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000910 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000911 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000912 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000913endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000914ifeq ($(CHECK_LIBUSB1), yes)
915 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
916 @echo "$$LIBUSB1_TEST" > .test.c
917 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
918 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
919 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000920 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000921 echo "Please install libusb-1.0 headers or disable all features"; \
922 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000923 echo "See README for more information."; echo; \
924 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
925 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
926 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
927 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
928 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000929 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000930 echo "Please install libusb-1.0 or disable all features"; \
931 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000932 echo "See README for more information."; echo; \
933 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
934 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
935endif
Marc Schink3578ec62016-03-17 16:23:03 +0100936ifeq ($(CHECK_LIBJAYLINK), yes)
937 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
938 @echo "$$LIBJAYLINK_TEST" > .test.c
939 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
940 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
941 echo "found." || { echo "not found."; echo; \
942 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
943 echo "Please install libjaylink headers or disable the feature"; \
944 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
945 echo "See README for more information."; echo; \
946 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
947 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
948 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
949 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
950 echo "yes." || { echo "no."; \
951 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
952 echo "Please install libjaylink or disable the feature"; \
953 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
954 echo "See README for more information."; echo; \
955 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
956 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
957endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000958
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000959.features: features
960
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000961# If a user does not explicitly request a non-working feature, we should
962# silently disable it. However, if a non-working (does not compile) feature
963# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000964# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000965featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000966ifeq ($(PROGRAMMER_OBJS),)
967 @echo "You have to enable at least one programmer driver!"
968 @false
969endif
970ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000971 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
972 @false
973endif
974
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000975features: compiler
976 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000977ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000978 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000979 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000980 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000981 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
982 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
983 printf "Checking for FT232H support in libftdi... " ; \
984 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000985 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000986 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
987 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
988 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
989 ) || \
990 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
991 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000992endif
David Hendricksf9a30552015-05-23 20:30:30 -0700993ifeq ($(CONFIG_LINUX_MTD), yes)
994 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
995 @echo "$$LINUX_MTD_TEST" > .featuretest.c
996 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
997 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
998 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
999 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1000 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1001endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001002ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001003 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001004 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001005 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001006 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001007 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001008 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1009 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001010endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001011ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001012 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001013 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001014 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001015 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001016 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001017 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1018 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001019endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001020ifeq ($(CONFIG_NI845X_SPI), yes)
1021 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1022 @echo "$$NI845X_TEST" > .featuretest.c
1023 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1024
1025 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1026 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1027 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1028 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1029 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1030 echo "For the NI-845x 17.0 the library path is:"; \
1031 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1032 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1033 exit 1; }; } \
1034 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1035endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001036 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001037 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001038 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001039 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001040 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001041 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001042 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001043ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1044 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1045 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1046else
Nico Huber8624e8c2012-11-05 21:46:33 +01001047 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1048 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1049 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1050 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1051 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1052 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001053endif
Stefan Tauner56787082011-08-18 02:27:19 +00001054 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1055 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001056
Stefan Tauner4c723152016-01-14 22:47:55 +00001057$(PROGRAM).8.html: $(PROGRAM).8
1058 @groff -mandoc -Thtml $< >$@
1059
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001060$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001061 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001062 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001063
1064install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001065 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001066 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001067 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001068 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001069
Nico Huber454f6132012-12-10 13:34:10 +00001070libinstall: libflashrom.a libflashrom.h
1071 mkdir -p $(DESTDIR)$(PREFIX)/lib
1072 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1073 mkdir -p $(DESTDIR)$(PREFIX)/include
1074 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1075
Nico Huber5f245a22023-01-10 17:14:47 +01001076versioninfo:
1077# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1078 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1079 @echo "VERSION = $(RELEASE)" > $@.inc
1080 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1081
Nico Huber26c2c4d2023-01-10 17:45:38 +01001082branch: versioninfo
1083 @git checkout -b $(RELEASE)
1084 @git add -f $<.inc
1085 @git commit -sm'Update version info for $(RELEASE)'
1086
1087tag: versioninfo
1088 @git add -f $<.inc
1089 @git commit -sm'Update version info for $(RELEASE)'
1090 @git tag -s $(RELEASE)
1091
Nico Huber5f245a22023-01-10 17:14:47 +01001092# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001093RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001094
Nico Huber1d58a902023-01-10 18:26:12 +01001095_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001096_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001097 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1098 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1099 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001100# Generate fresh versioninfo.inc and compare
1101 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1102 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1103 "$(EXPORT_VERSIONINFO)"
1104 @if [ -f versioninfo.inc ]; then \
1105 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1106 { echo Error: Version info changed:; \
1107 cat "$(EXPORT_VERSIONINFO)"; \
1108 echo Update versioninfo.inc and tag accordingly.; \
1109 exit 1; \
1110 }; \
1111 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001112# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1113# sed is required to filter out file names having the attribute set.
1114# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1115# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001116 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1117 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001118 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001119 xargs -0 sh -c 'for f; do \
1120 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001121 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001122 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001123
Stefan Tauner76347082016-11-27 17:45:49 +01001124export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001125 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001126
1127tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001128 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1129 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001130# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001131 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1132 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001133
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001134libpayload: clean
1135 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001136
Felix Singer9441c6e2022-10-21 12:47:11 +02001137gitconfig:
1138 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1139
Nico Huber26c2c4d2023-01-10 17:45:38 +01001140.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001141
Stefan Tauner23e10b82016-01-23 16:16:49 +00001142# Disable implicit suffixes and built-in rules (for performance and profit)
1143.SUFFIXES:
1144
Stefan Reinauere2f01582010-06-07 11:08:07 +00001145-include $(OBJS:.o=.d)